//+--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------+
//|                                                                                                                                                                  InsideBar.mq5 |
//|                                                                                                                                                                            hoz |
//|                                                                                                                                                                                |
//+--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------+
#property copyright "hoz"
#property link      ""
#property version   "1.00"
#property indicator_chart_window
#property indicator_buffers 6
#property indicator_plots 4

#property indicator_type1 DRAW_COLOR_ARROW
#property indicator_color1  clrRed, clrTurquoise, clrGoldenrod

#property indicator_type2 DRAW_COLOR_ARROW
#property indicator_color2  clrRed, clrTurquoise, clrIndigo

#property indicator_type3 DRAW_COLOR_ARROW
#property indicator_color3  clrRed, clrTurquoise, clrGoldenrod

#property indicator_type4 DRAW_COLOR_ARROW
#property indicator_color4  clrRed, clrTurquoise, clrIndigo/**/
// ====================================================================== Включения и импорт внешних модулей ======================================================================+
#include <HOZ_Code\Enums\Location.mqh>

#import "EnvironmentInfo\TimeSeries.ex5"
  int barsTotal(ENUM_TIMEFRAMES tf = PERIOD_CURRENT);
  int barShift(datetime initialBarTime, ENUM_TIMEFRAMES tf = PERIOD_CURRENT);
  double barHighPrice(int shift, ENUM_TIMEFRAMES tf = PERIOD_CURRENT);
  double barLowPrice(int shift, ENUM_TIMEFRAMES tf = PERIOD_CURRENT);
  double barOpenPrice(int shift, ENUM_TIMEFRAMES tf = PERIOD_CURRENT);
  double barClosePrice(int shift, ENUM_TIMEFRAMES tf = PERIOD_CURRENT);
  datetime barOpenTime(int shift, ENUM_TIMEFRAMES tf = PERIOD_CURRENT);
#import "Indicator\DataMapping.ex5"
  void drawPatternInfo(string prefix, string patternName, int index, ENUM_LOCATION textLocation, color clr);
#import

#include <HOZ_Code\Classes\Environment\SymbolInstance.mqh>

// ===============================================================================  Input переменные  =============================================================================+
input bool    checkBarBodySize = false;               // Проверять размер тела бара?
input double  insideBarMinBodySize = 1.0;             // Минимальный размер тела паттерна 'Внутренний бар'
input double  insideBarMaxBodySize = INT_MAX;         // Максимальный размер тела паттерна 'Внутренний бар'
input bool    checkBarShadowSize = false;             // Проверять размер тени бара?
input double  insideBarLowerShadowSize = 150.0;       // Относительный размер нижней тени паттерна 'Внутренний бар'
input double  insideBarUpperShadowSize = 150.0;       // Абсолютный размер верхней тени паттерна 'Внутренний бар'

input int     arrowShift = 10;
input bool    toDrawPatternsInfo = false;
input int     barsToCalculate = 3321;

SymbolInstance *ptrSym;

double insideBarWithBearishBody_buffer[];             // Буфер паттерна "Внутренний бар" с медвежьим телом бара
double insideBarWithBullishBody_buffer[];             // Буфер паттерна "Внутренний бар" с бычьим телом бара
double insideBarWithBearishBody_upperArrowColor[];    // Буфер цвета верхней стрелочки, располагающейся над паттерном "Внутренний бар" с медвежьим телом бара
double insideBarWithBearishBody_lowerArrowColor[];    // Буфер цвета нижней стрелочки, располагающейся под паттерном "Внутренний бар" с медвежьим телом бара
double insideBarWithBullishBody_upperArrowColor[];    // Буфер цвета верхней стрелочки, располагающейся над паттерном "Внутренний бар" с бычьим телом бара
double insideBarWithBullishBody_lowerArrowColor[];    // Буфер цвета нижней стрелочки, располагающейся под паттерном "Внутренний бар" с бычьим телом бара

int    firstBarIndexToCalculate;

#define PREFIX "PA_PATTERN"                  // Префикс имён графических объектов

#define INSIDE_BAR_WITH_BEARISH_BODY   "Inside bar with bearish body"
#define INSIDE_BAR_WITH_BULLISH_BODY   "Inside bar with bullish body"
//==================================================================================================================================================================================
// Custom indicator initialization function. =======================================================================================================================================
int OnInit() {
  ptrSym = new SymbolInstance(_Symbol);

  IndicatorSetString(INDICATOR_SHORTNAME, "Inside bar");
  IndicatorSetInteger(INDICATOR_DIGITS, _Digits);

  // === Связывание буферов с индексами, определение стилей ==========================
  SetIndexBuffer(0, insideBarWithBearishBody_buffer, INDICATOR_DATA);                    // 1-ый буфер - "Молот" с медвежьим телом бара
  SetIndexBuffer(1, insideBarWithBullishBody_buffer, INDICATOR_DATA);                    // 4-ый буфер - "Молот" с бычьим телом бара
  SetIndexBuffer(2, insideBarWithBearishBody_upperArrowColor, INDICATOR_COLOR_INDEX);    // 2-ой буфер - Цвет верхней стрелочки
  SetIndexBuffer(3, insideBarWithBearishBody_lowerArrowColor, INDICATOR_COLOR_INDEX);    // 3-ий буфер - Цвет нижней стрелочки

  SetIndexBuffer(4, insideBarWithBullishBody_upperArrowColor, INDICATOR_COLOR_INDEX);    // 5-ый буфер - Цвет верхней стрелочки
  SetIndexBuffer(5, insideBarWithBullishBody_lowerArrowColor, INDICATOR_COLOR_INDEX);    // 6-ой буфер - Цвет нижней стрелочки

  PlotIndexSetInteger(0, PLOT_DRAW_TYPE, DRAW_COLOR_ARROW);
  PlotIndexSetInteger(0, PLOT_ARROW, 218);
  PlotIndexSetInteger(0, PLOT_ARROW_SHIFT, -arrowShift);
  PlotIndexSetDouble(0, PLOT_EMPTY_VALUE, EMPTY_VALUE);

  PlotIndexSetInteger(1, PLOT_DRAW_TYPE, DRAW_COLOR_ARROW);
  PlotIndexSetInteger(1, PLOT_ARROW, 217);
  PlotIndexSetInteger(1, PLOT_ARROW_SHIFT, arrowShift);
  PlotIndexSetDouble(1, PLOT_EMPTY_VALUE, EMPTY_VALUE);

  PlotIndexSetInteger(2, PLOT_DRAW_TYPE, DRAW_COLOR_ARROW);
  PlotIndexSetInteger(2, PLOT_ARROW, 218);
  PlotIndexSetInteger(2, PLOT_ARROW_SHIFT, -arrowShift);
  PlotIndexSetDouble(2, PLOT_EMPTY_VALUE, EMPTY_VALUE);

  PlotIndexSetInteger(3, PLOT_DRAW_TYPE, DRAW_COLOR_ARROW);
  PlotIndexSetInteger(3, PLOT_ARROW, 217);
  PlotIndexSetInteger(3, PLOT_ARROW_SHIFT, arrowShift);
  PlotIndexSetDouble(3, PLOT_EMPTY_VALUE, EMPTY_VALUE);

  ArraySetAsSeries(insideBarWithBearishBody_buffer, true);
  ArraySetAsSeries(insideBarWithBearishBody_upperArrowColor, true);
  ArraySetAsSeries(insideBarWithBearishBody_lowerArrowColor, true);
  ArraySetAsSeries(insideBarWithBullishBody_buffer, true);
  ArraySetAsSeries(insideBarWithBullishBody_upperArrowColor, true);
  ArraySetAsSeries(insideBarWithBullishBody_lowerArrowColor, true);
//---
   return INIT_SUCCEEDED;
}
//==================================================================================================================================================================================
// Custom indicator initialization function. =======================================================================================================================================
void OnDeinit(const int reason) {
  delete ptrSym;
  deleteAllObjects();
}
//==================================================================================================================================================================================
// Удаление всех объектов, созданных индикатором. ==================================================================================================================================
void deleteAllObjects() {
  ObjectsDeleteAll(0, PREFIX, 0, -1);
}
//==================================================================================================================================================================================
// setter значений индикаторных буферов. ===========================================================================================================================================
void setBuffers(string patternType,    // Тип паттерна
                int i) {               // Индекс обрабатываемого бара
  if (patternType == INSIDE_BAR_WITH_BEARISH_BODY) {
    insideBarWithBearishBody_buffer[i] = barHighPrice(i);
    insideBarWithBullishBody_buffer[i] = EMPTY_VALUE;
    insideBarWithBearishBody_upperArrowColor[i] = 0;
    insideBarWithBearishBody_lowerArrowColor[i] = 0;
  } else if (patternType == INSIDE_BAR_WITH_BULLISH_BODY) {
    insideBarWithBullishBody_buffer[i] = barLowPrice(i);
    insideBarWithBearishBody_buffer[i] = EMPTY_VALUE;
    insideBarWithBullishBody_upperArrowColor[i] = 0;
    insideBarWithBullishBody_lowerArrowColor[i] = 0;
  }
}
//==================================================================================================================================================================================
// Поиск паттерна Hammer with bearish body. ========================================================================================================================================
void findInsideBarWithBearishBody(int i) {
  double bodySize = barOpenPrice(i) - barClosePrice(i);
  double lowerShadowSize = barClosePrice(i) - barLowPrice(i);
  double upperShadowSize = barHighPrice(i) - barOpenPrice(i);
  
  if (barHighPrice(i) > barHighPrice(i + 1) || barLowPrice(i) < barLowPrice(i + 1)) return;
  if (checkBarBodySize) {
    if (bodySize < insideBarMinBodySize * ptrSym.pt() || bodySize > insideBarMaxBodySize * ptrSym.pt()) return;
  }
  if (checkBarShadowSize) {
    if (upperShadowSize > insideBarUpperShadowSize * ptrSym.pt() || lowerShadowSize > insideBarLowerShadowSize * ptrSym.pt()) return;
  }
  
  setBuffers(INSIDE_BAR_WITH_BEARISH_BODY, i);

  if (toDrawPatternsInfo)
    drawPatternInfo(PREFIX, INSIDE_BAR_WITH_BEARISH_BODY, i, LOCATION_ABOVE, clrBlack);
}
//==================================================================================================================================================================================
// Поиск паттерна Hammer with bullish body. ========================================================================================================================================
void findInsideBarWithBullishBody(int i) {
  double bodySize = barClosePrice(i) - barOpenPrice(i);
  double lowerShadowSize = barOpenPrice(i) - barLowPrice(i);
  double upperShadowSize = barHighPrice(i) - barClosePrice(i);
  
  if (barHighPrice(i) > barHighPrice(i + 1) || barLowPrice(i) < barLowPrice(i + 1)) return;
  if (checkBarBodySize) {
    if (bodySize < insideBarMinBodySize * ptrSym.pt() || bodySize > insideBarMaxBodySize * ptrSym.pt()) return;
  }
  if (checkBarShadowSize) {
    if (upperShadowSize > insideBarUpperShadowSize * ptrSym.pt() || lowerShadowSize > insideBarLowerShadowSize * ptrSym.pt()) return;
  }
  
  setBuffers(INSIDE_BAR_WITH_BULLISH_BODY, i);
  
  if (toDrawPatternsInfo)
    drawPatternInfo(PREFIX, INSIDE_BAR_WITH_BULLISH_BODY, i, LOCATION_BELOW, clrBlack);
}
//==================================================================================================================================================================================
// Расчет значений индикатора. =====================================================================================================================================================
void checkingPatterns(int limit) {
  for (int i = limit; i > 0; i--) {
    findInsideBarWithBearishBody(i);
    findInsideBarWithBullishBody(i);
  }
}
//==================================================================================================================================================================================
// Определение индекса бара, с которого необходимо производить перерасчет. =========================================================================================================
int recalcIndex(int calculatedYet) {
  firstBarIndexToCalculate = barsTotal() - 1;

  if (calculatedYet == 0) {
    ArrayInitialize(insideBarWithBearishBody_buffer, EMPTY_VALUE);
    ArrayInitialize(insideBarWithBearishBody_upperArrowColor, EMPTY_VALUE);
    ArrayInitialize(insideBarWithBearishBody_lowerArrowColor, EMPTY_VALUE);
    ArrayInitialize(insideBarWithBullishBody_buffer, EMPTY_VALUE);
    ArrayInitialize(insideBarWithBullishBody_upperArrowColor, EMPTY_VALUE);
    ArrayInitialize(insideBarWithBullishBody_lowerArrowColor, EMPTY_VALUE);

    if (barsToCalculate > 0 && barsToCalculate < firstBarIndexToCalculate)    // Если не нужно рассчитывать всю..
      firstBarIndexToCalculate = barsToCalculate;                             // ..историю, то начнем с указанного..

    return firstBarIndexToCalculate;
  }
  return 2;
}
//==================================================================================================================================================================================
// Custom indicator iteration function. ============================================================================================================================================
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime& time[],
                const double& open[],
                const double& high[],
                const double& low[],
                const double& close[],
                const long& tick_volume[],
                const long& volume[],
                const int& spread[]) {
//---
  if (ChartGetDouble(0, CHART_FIXED_MAX) <= 0 || ChartGetDouble(0, CHART_FIXED_MIN) <= 0) {
    Print("max = ", ChartGetDouble(0, CHART_FIXED_MAX));
    Print("min = ", ChartGetDouble(0, CHART_FIXED_MIN));
    return -1;
  }
  
  int limit = recalcIndex(prev_calculated);
  checkingPatterns(limit);
  
//--- return value of prev_calculated for next call
  return rates_total;
}